diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/test/random-variable-stream-test-suite.cc ns-3.32/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.31/src/core/test/random-variable-stream-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/test/random-variable-stream-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -42,106 +42,324 @@
 
 NS_LOG_COMPONENT_DEFINE ("RandomVariableStreamGenerators");
 
-namespace {
+namespace ns3 {
 
-void
-FillHistoRangeUniformly (double *array, uint32_t n, double start, double end)
-{
-  double increment = (end - start) / (n - 1.);
-  double d = start;
-
-  for (uint32_t i = 0; i < n; ++i)
-    {
-      array[i] = d;
-      d += increment;
-    }
-}
-
-bool seedSet = false;
-
-// Over time, this test suite is designed to be run with varying seed
-// values so that the distributions can be evaluated with chi-squared
-// tests.  To enable this, normal invocation of this test suite will
-// result in a seed value corresponding to the seconds since epoch
-// (time (0) from ctime).  Note: this is not a recommended practice for
-// seeding normal simulations, as described in the ns-3 manual, but
-// suits our purposes here.
-//
-// However, we also want to provide the ability to run this test suite
-// with a repeatable value, such as when the seed or run number is configured
-// to a specific value.  Therefore, we adopt the following policy.  When
-// the test program is being run with the default global values for seed
-// and run number, this function will instead pick a random, time-based
-// seed for use within this test suite.  If the global values for seed or
-// run number have been configured differently from the default values,
-// the global seed value will be used instead of the time-based one.
-//
-// For example, this command will cause this test suite to use the
-// deterministic value of seed=3 every time:
-//   NS_GLOBAL_VALUE="RngSeed=3" ./test.py -s random-variable-stream-generators
-// or equivalently (to see log output):
-//   NS_LOG="RandomVariableStreamGenerators" NS_GLOBAL_VALUE="RngSeed=3" ./waf --run "test-runner --suite=random-variable-stream-generators"
-//  Similarly, if the value of RngRun is not set to 1, the globals will be
-//  used.
-//
-void
-SetTestSuiteSeed (void)
-{
-  if (seedSet == false)
-    {
-      uint32_t seed;
-      if (RngSeedManager::GetSeed () == 1 && RngSeedManager::GetRun () == 1)
-        {
-          seed = static_cast<uint32_t> (time (0));
-          seedSet = true;
-          NS_LOG_DEBUG ("Global seed and run number are default; seeding with time of day: " << seed);
-
-        }
-      else
-        {
-          seed = RngSeedManager::GetSeed ();
-          seedSet = true;
-          NS_LOG_DEBUG ("Global seed and run number are not default; using the non-default values seed: " <<
-                        seed << " and run: " << RngSeedManager::GetRun ());
-        }
-      SeedManager::SetSeed (seed);
-    }
-}
-
-} // anonymous namespace
-
-// ===========================================================================
-// Test case for uniform distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamUniformTestCase : public TestCase
-{
-public:
-  // We want the number of observations in each bin to be > 5
-  // The following values should yield many more than 5 per bin
-  static const uint32_t N_BINS = 100;
-  static const uint32_t N_MEASUREMENTS = 1000000;
+namespace test {
 
-  // Number of times to wrap the Chi-Squared test and retry
-  static const uint32_t N_RUNS = 2;
+namespace RandomVariable {
 
-  RandomVariableStreamUniformTestCase ();
-  virtual ~RandomVariableStreamUniformTestCase ();
-
-  double ChiSquaredTest (Ptr<UniformRandomVariable> u);
+/**
+ * Base class for RandomVariableStream test suites.
+ */
+class TestCaseBase : public TestCase
+{
+public:
+  /** Number of bins for sampling the distributions. */
+  static const uint32_t N_BINS {50};
+  /** Number of samples to draw when populating the distributions. */
+  static const uint32_t N_MEASUREMENTS {1000000};
+  /** Number of retry attempts to pass a chi-square test. */
+  static const uint32_t N_RUNS {5};
+
+  /**
+   * Constructor
+   * \param [in] name The test case name.
+   */
+  TestCaseBase (std::string name)
+    : TestCase (name)
+  {}
+
+  /**
+   * Configure a GSL histogram with uniform bins, with optional
+   * under/over-flow bins.
+   * \param [in,out] h The GSL histogram to configure.
+   * \param [in] start The minimum value of the lowest bin.
+   * \param [in] end The maximum value of the last bin.
+   * \param [in] underflow If \c true the lowest bin should contain the underflow,
+   * \param [in] overflow If \c ture the highest bin should contain the overflow.
+   * \returns A vector of the bin edges, including the top of the highest bin.
+   * This vector has one more entry than the number of bins in the histogram.
+   */
+  std::vector<double>
+  UniformHistogramBins (gsl_histogram *h, double start, double end,
+                      bool underflow = true, bool overflow = true) const
+  {
+    NS_LOG_FUNCTION (this << h << start << end);
+    std::size_t nBins = gsl_histogram_bins (h);
+    double increment = (end - start) / (nBins - 1.);
+    double d = start;
+
+    std::vector<double> range (nBins + 1);
+
+    for (auto & r : range)
+      {
+        r = d;
+        d += increment;
+      }
+    if (underflow)
+      {
+        range[0] = -std::numeric_limits<double>::max ();
+      }
+    if (overflow)
+      {
+        range[nBins] = std::numeric_limits<double>::max ();
+      }
+
+    gsl_histogram_set_ranges (h, range.data (), nBins + 1);
+    return range;
+  }
+
+  /**
+   * Compute the average of a random variable.
+   * \param [in] rng The random variable to sample.
+   * \returns The average of \c N_MEASUREMENTS samples.
+   */
+  double
+  Average (Ptr<RandomVariableStream> rng) const
+  {
+    NS_LOG_FUNCTION (this << rng);
+    double sum = 0.0;
+    for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
+      {
+        double value = rng->GetValue ();
+        sum += value;
+      }
+    double valueMean = sum / N_MEASUREMENTS;
+    return valueMean;
+  }
+
+  /** A factory base class to create new instances of a random variable. */
+  class RngGeneratorBase
+  {
+  public:
+    /**
+     * Create a new instance of a random variable stream
+     * \returns The new random variable stream instance.
+     */
+    virtual Ptr<RandomVariableStream> Create (void) const = 0;
+  };
+
+  /**
+   * Factory class to create new instances of a particular random variable stream.
+   *
+   * \tparam RNG The type of random variable generator to create.
+   */
+  template <typename RNG>
+  class RngGenerator : public RngGeneratorBase
+  {
+  public:
+    /**
+     * Constructor.
+     * \param [in] anti Create antithetic streams if \c true.
+     */
+    RngGenerator (bool anti = false)
+      : m_anti (anti)
+    {}
+
+    // Inherited
+    Ptr<RandomVariableStream>
+    Create (void) const
+    {
+      auto rng = CreateObject<RNG> ();
+      rng->SetAttribute ("Antithetic", BooleanValue (m_anti));
+      return rng;
+    }
+
+  private:
+    /** Whether to create antithetic random variable streams. */
+    bool m_anti;
+  };
+
+  /**
+   * Compute the chi squared value of a sampled distribution
+   * compared to the expected distribution.
+   *
+   * This function captures the actual computation of the chi square,
+   * given an expected distribution.
+   *
+   * The random variable is sampled \c N_MEASUREMENTS times, filling
+   * a histogram. The chi square value is formed by comparing to the
+   * expected distribution.
+   * \param [in,out] h The histogram, which defines the binning for sampling.
+   * \param [in] expected The expected distribution.
+   * \param [in] rng The random variable to sample.
+   * \returns The chi square value.
+   */
+  double
+  ChiSquared (gsl_histogram * h,
+                const std::vector<double> & expected,
+                Ptr<RandomVariableStream> rng) const
+  {
+    NS_LOG_FUNCTION (this << h << expected.size () << rng);
+    NS_ASSERT_MSG (gsl_histogram_bins (h) == expected.size (),
+                   "Histogram and expected vector have different sizes.");
+
+    // Sample the rng into the histogram
+    for (std::size_t i = 0; i < N_MEASUREMENTS; ++i)
+      {
+        double value = rng->GetValue ();
+        gsl_histogram_increment (h, value);
+      }
+
+    // Compute the chi square value
+    double chiSquared = 0;
+    std::size_t nBins = gsl_histogram_bins (h);
+    for (std::size_t i = 0; i < nBins; ++i)
+      {
+        double hbin = gsl_histogram_get (h, i);
+        double tmp = hbin - expected[i];
+        tmp *= tmp;
+        tmp /= expected[i];
+        chiSquared += tmp;
+      }
+
+    return chiSquared;
+  }
+
+  /**
+   * Compute the chi square value from a random variable.
+   *
+   * This function sets up the binning and expected distribution
+   * needed to actually compute the chi squared value, which
+   * should be done by a call to ChiSquared.
+   *
+   * This is the point of customization expected to be implemented
+   * in derived classes with the appropriate histogram binning and
+   * expected distribution.  For example
+   *
+   *    SomeRngTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
+   *    {
+   *      gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+   *      auto range = UniformHistogramBins (h, -4., 4.);
+   *      std::vector<double> expected (N_BINS);
+   *      // Populated expected
+   *      for (std::size_t i = 0; i < N_BINS; ++i)
+   *        {
+   *          expected[i] = ...;
+   *          expected[i] *= N_MEASUREMENTS;
+   *        }
+   *      double chiSquared = ChiSquared (h, expected, rng);
+   *      gsl_histogram_free (h);
+   *      return chiSquared;
+   *    }
+   *
+   * \param [in] rng The random number generator to test.
+   * \returns The chi squared value.
+   */
+  virtual double
+  ChiSquaredTest (Ptr<RandomVariableStream> rng) const
+  {
+    return 0;
+  }
+
+  /**
+   * Average the chi squared value over some number of runs,
+   * each run with a new instance of the random number generator.
+   * \param [in] generator The factory to create instances of the
+   *             random number generator.
+   * \param [in] nRuns The number of runs to average over.
+   * \returns The average chi square over the number of runs.
+   */
+  double
+  ChiSquaredsAverage (const RngGeneratorBase * generator,
+                        std::size_t nRuns) const
+  {
+    NS_LOG_FUNCTION (this << generator << nRuns);
+    
+    double sum = 0.;
+    for (std::size_t i = 0; i < nRuns; ++i)
+      {
+        auto rng = generator->Create ();
+        double result = ChiSquaredTest (rng);
+        sum += result;
+      }
+    sum /= (double)nRuns;
+    return sum;
+  }
+
+  /**
+   * Set the seed used for this test suite.
+   *
+   * Over time, this test suite is designed to be run with varying seed
+   * values so that the distributions can be evaluated with chi-squared
+   * tests.  To enable this, normal invocation of this test suite will
+   * result in a seed value corresponding to the seconds since epoch
+   * (\c time (0) from \c ctime).  Note: this is not a recommended practice for
+   * seeding normal simulations, as described in the ns-3 manual, but
+   * suits our purposes here.
+   *
+   * However, we also want to provide the ability to run this test suite 
+   * with a repeatable value, such as when the seed or run number is configured
+   * to a specific value.  Therefore, we adopt the following policy.  When
+   * the test program is being run with the default global values for seed
+   * and run number, this function will instead pick a random, time-based
+   * seed for use within this test suite.  If the global values for seed or
+   * run number have been configured differently from the default values,
+   * the global seed value will be used instead of the time-based one.
+   *
+   * For example, this command will cause this test suite to use the
+   * deterministic value of seed=3 every time:
+   *   NS_GLOBAL_VALUE="RngSeed=3" ./test.py -s random-variable-stream-generators
+   * or equivalently (to see log output):
+   *   NS_LOG="RandomVariableStreamGenerators" NS_GLOBAL_VALUE="RngSeed=3" ./waf --run "test-runner --suite=random-variable-stream-generators"
+   *  Similarly, if the value of RngRun is not set to 1, the globals will be
+   *  used.
+   */
+  void
+  SetTestSuiteSeed (void)
+  {
+    if (m_seedSet == false)
+      {
+        uint32_t seed;
+        if (RngSeedManager::GetSeed () == 1 && RngSeedManager::GetRun () == 1)
+          {
+            seed = static_cast<uint32_t> (time (0));
+            m_seedSet = true;
+            NS_LOG_DEBUG ("Global seed and run number are default; seeding with time of day: " << seed);
+
+          }
+        else
+          {
+            seed = RngSeedManager::GetSeed ();
+            m_seedSet = true;
+            NS_LOG_DEBUG ("Global seed and run number are not default; using the non-default values seed: " <<
+                          seed << " and run: " << RngSeedManager::GetRun ());
+          }
+        SeedManager::SetSeed (seed);
+      }
+  }
+
+private:
+  /** \c true if we've already set the seed the correctly. */
+  bool m_seedSet = false;
+
+}; // class TestCaseBase
+
+
+/**
+ * Test case for uniform distribution random variable stream generator.
+ */
+class UniformTestCase : public TestCaseBase
+{
+public:
+
+  // Constructor
+  UniformTestCase ();
+
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
 };
 
-RandomVariableStreamUniformTestCase::RandomVariableStreamUniformTestCase ()
-  : TestCase ("Uniform Random Variable Stream Generator")
-{}
-
-RandomVariableStreamUniformTestCase::~RandomVariableStreamUniformTestCase ()
+UniformTestCase::UniformTestCase ()
+  : TestCaseBase ("Uniform Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamUniformTestCase::ChiSquaredTest (Ptr<UniformRandomVariable> u)
+UniformTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
 
@@ -149,38 +367,17 @@
   // the default range for this distribution.
   gsl_histogram_set_ranges_uniform (h, 0., 1.);
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, u->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  double expected = ((double)N_MEASUREMENTS / (double)N_BINS);
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected;
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected;
-    }
+  std::vector<double> expected (N_BINS, ((double)N_MEASUREMENTS / (double)N_BINS));
 
+  double chiSquared = ChiSquared (h, expected, rng);
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamUniformTestCase::DoRun (void)
+UniformTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
   double confidence = 0.99;
@@ -191,8 +388,8 @@
   // If chi-squared test fails, re-try it up to N_RUNS times
   for (uint32_t i = 0; i < N_RUNS; ++i)
     {
-      Ptr<UniformRandomVariable> u = CreateObject<UniformRandomVariable> ();
-      result = ChiSquaredTest (u);
+      Ptr<UniformRandomVariable> rng = CreateObject<UniformRandomVariable> ();
+      result = ChiSquaredTest (rng);
       NS_LOG_DEBUG ("Chi square result is " << result);
       if (result < maxStatistic)
         {
@@ -224,8 +421,8 @@
     }
 
   // Boundary checking on GetInteger; should be [min,max]; from bug 1964
-  static const uint32_t UNIFORM_INTEGER_MIN = 0;
-  static const uint32_t UNIFORM_INTEGER_MAX = 4294967295U;
+  static const uint32_t UNIFORM_INTEGER_MIN {0};
+  static const uint32_t UNIFORM_INTEGER_MAX {4294967295U};
   // [0,0] should return 0
   uint32_t intValue;
   intValue = x->GetInteger (UNIFORM_INTEGER_MIN, UNIFORM_INTEGER_MIN);
@@ -260,34 +457,30 @@
 
 }
 
-// ===========================================================================
-// Test case for antithetic uniform distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamUniformAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic uniform distribution random variable stream generator
+ */
+class UniformAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
 
-  RandomVariableStreamUniformAntitheticTestCase ();
-  virtual ~RandomVariableStreamUniformAntitheticTestCase ();
+  // Constructor
+  UniformAntitheticTestCase ();
 
-  double ChiSquaredTest (Ptr<UniformRandomVariable> u);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
 };
 
-RandomVariableStreamUniformAntitheticTestCase::RandomVariableStreamUniformAntitheticTestCase ()
-  : TestCase ("Antithetic Uniform Random Variable Stream Generator")
-{}
-
-RandomVariableStreamUniformAntitheticTestCase::~RandomVariableStreamUniformAntitheticTestCase ()
+UniformAntitheticTestCase::UniformAntitheticTestCase ()
+  : TestCaseBase ("Antithetic Uniform Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamUniformAntitheticTestCase::ChiSquaredTest (Ptr<UniformRandomVariable> u)
+UniformAntitheticTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
 
@@ -295,56 +488,22 @@
   // the default range for this distribution.
   gsl_histogram_set_ranges_uniform (h, 0., 1.);
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, u->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  double expected = ((double)N_MEASUREMENTS / (double)N_BINS);
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected;
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected;
-    }
+  std::vector<double> expected (N_BINS, ((double)N_MEASUREMENTS / (double)N_BINS));
 
+  double chiSquared = ChiSquared (h, expected, rng);
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamUniformAntitheticTestCase::DoRun (void)
+UniformAntitheticTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<UniformRandomVariable> (true);
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<UniformRandomVariable> u = CreateObject<UniformRandomVariable> ();
-
-      // Make this generate antithetic values.
-      u->SetAttribute ("Antithetic", BooleanValue (true));
-
-      double result = ChiSquaredTest (u);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double min = 0.0;
@@ -373,35 +532,31 @@
 
 
 }
-
-// ===========================================================================
-// Test case for constant random variable stream generator
-// ===========================================================================
-class RandomVariableStreamConstantTestCase : public TestCase
+/**
+ * Test case for constant random variable stream generator
+ */
+class ConstantTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_MEASUREMENTS = 1000000;
-  static const double TOLERANCE;
-
-  RandomVariableStreamConstantTestCase ();
-  virtual ~RandomVariableStreamConstantTestCase ();
+  // Constructor
+  ConstantTestCase ();
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-const double RandomVariableStreamConstantTestCase::TOLERANCE = 1e-8;
-
-RandomVariableStreamConstantTestCase::RandomVariableStreamConstantTestCase ()
-  : TestCase ("Constant Random Variable Stream Generator")
-{}
+  /** Tolerance for testing rng values against expectation. */
+  static constexpr double TOLERANCE {1e-8};
+};
 
-RandomVariableStreamConstantTestCase::~RandomVariableStreamConstantTestCase ()
+ConstantTestCase::ConstantTestCase ()
+  : TestCaseBase ("Constant Random Variable Stream Generator")
 {}
 
 void
-RandomVariableStreamConstantTestCase::DoRun (void)
+ConstantTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
   Ptr<ConstantRandomVariable> c = CreateObject<ConstantRandomVariable> ();
@@ -423,33 +578,31 @@
     }
 }
 
-// ===========================================================================
-// Test case for sequential random variable stream generator
-// ===========================================================================
-class RandomVariableStreamSequentialTestCase : public TestCase
+/**
+ * Test case for sequential random variable stream generator
+ */
+class SequentialTestCase : public TestCaseBase
 {
 public:
-  static const double TOLERANCE;
-
-  RandomVariableStreamSequentialTestCase ();
-  virtual ~RandomVariableStreamSequentialTestCase ();
+  // Constructor
+  SequentialTestCase ();
 
 private:
+  // Inherited
   virtual void DoRun (void);
+  
+  /** Tolerance for testing rng values against expectation. */
+  static constexpr double TOLERANCE {1e-8};
 };
 
-const double RandomVariableStreamSequentialTestCase::TOLERANCE = 1e-8;
-
-RandomVariableStreamSequentialTestCase::RandomVariableStreamSequentialTestCase ()
-  : TestCase ("Sequential Random Variable Stream Generator")
-{}
-
-RandomVariableStreamSequentialTestCase::~RandomVariableStreamSequentialTestCase ()
+SequentialTestCase::SequentialTestCase ()
+  : TestCaseBase ("Sequential Random Variable Stream Generator")
 {}
 
 void
-RandomVariableStreamSequentialTestCase::DoRun (void)
+SequentialTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
   Ptr<SequentialRandomVariable> s = CreateObject<SequentialRandomVariable> ();
@@ -481,106 +634,69 @@
 
 }
 
-// ===========================================================================
-// Test case for normal distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamNormalTestCase : public TestCase
+/**
+ * Test case for normal distribution random variable stream generator
+ */
+class NormalTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
+  // Constructor
+  NormalTestCase ();
 
-  RandomVariableStreamNormalTestCase ();
-  virtual ~RandomVariableStreamNormalTestCase ();
-
-  double ChiSquaredTest (Ptr<NormalRandomVariable> n);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamNormalTestCase::RandomVariableStreamNormalTestCase ()
-  : TestCase ("Normal Random Variable Stream Generator")
-{}
+  /** Tolerance for testing rng values against expectation, in rms. */
+  static constexpr double TOLERANCE {5};  
+};
 
-RandomVariableStreamNormalTestCase::~RandomVariableStreamNormalTestCase ()
+NormalTestCase::NormalTestCase ()
+  : TestCaseBase ("Normal Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamNormalTestCase::ChiSquaredTest (Ptr<NormalRandomVariable> n)
+NormalTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, -4., 4.);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, -4., 4.);
-  range[0] = -std::numeric_limits<double>::max ();
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that n has mean equal to zero and standard
   // deviation equal to one, which are their default values for this
   // distribution.
   double sigma = 1.;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_gaussian_P (range[i + 1], sigma) - gsl_cdf_gaussian_P (range[i], sigma);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, n->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
-
+  double chiSquared = ChiSquared (h, expected, rng);
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamNormalTestCase::DoRun (void)
+NormalTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<NormalRandomVariable> ();
+  auto rng = generator.Create ();
+  
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<NormalRandomVariable> n = CreateObject<NormalRandomVariable> ();
-      double result = ChiSquaredTest (n);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double mean = 5.0;
   double variance = 2.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<NormalRandomVariable> x = CreateObject<NormalRandomVariable> ();
@@ -588,127 +704,79 @@
   x->SetAttribute ("Variance", DoubleValue (variance));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // normally distributed random variable is equal to mean.
   double expectedMean = mean;
+  double expectedRms  = mean / std::sqrt (variance * N_MEASUREMENTS);
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedRms * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for antithetic normal distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamNormalAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic normal distribution random variable stream generator
+ */
+class NormalAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamNormalAntitheticTestCase ();
-  virtual ~RandomVariableStreamNormalAntitheticTestCase ();
+  // Constructor
+  NormalAntitheticTestCase ();
 
-  double ChiSquaredTest (Ptr<NormalRandomVariable> n);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamNormalAntitheticTestCase::RandomVariableStreamNormalAntitheticTestCase ()
-  : TestCase ("Antithetic Normal Random Variable Stream Generator")
-{}
+  /** Tolerance for testing rng values against expectation, in rms. */
+  static constexpr double TOLERANCE {5};  
+};
 
-RandomVariableStreamNormalAntitheticTestCase::~RandomVariableStreamNormalAntitheticTestCase ()
+NormalAntitheticTestCase::NormalAntitheticTestCase ()
+  : TestCaseBase ("Antithetic Normal Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamNormalAntitheticTestCase::ChiSquaredTest (Ptr<NormalRandomVariable> n)
+NormalAntitheticTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, -4, 4);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, -4., 4.);
-  range[0] = -std::numeric_limits<double>::max ();
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that n has mean equal to zero and standard
   // deviation equal to one, which are their default values for this
   // distribution.
   double sigma = 1.;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_gaussian_P (range[i + 1], sigma) - gsl_cdf_gaussian_P (range[i], sigma);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, n->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamNormalAntitheticTestCase::DoRun (void)
+NormalAntitheticTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<NormalRandomVariable> (true);
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<NormalRandomVariable> n = CreateObject<NormalRandomVariable> ();
-
-      // Make this generate antithetic values.
-      n->SetAttribute ("Antithetic", BooleanValue (true));
-
-      double result = ChiSquaredTest (n);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double mean = 5.0;
   double variance = 2.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<NormalRandomVariable> x = CreateObject<NormalRandomVariable> ();
